import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Locale;
import java.util.Vector;

import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.JWindow;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.JCheckBox;
import javax.swing.filechooser.FileFilter;

/**
 * @author Markus Bttcher
 * 
 */
public class AQuaProg extends JFrame {

	private static final long serialVersionUID = 1L;

	MyMemoryMonitor mmm = null;

	Thread mmmt = null;

	private JPanel jContentPane = null;

	private JMenuBar jJMenuBar = null;

	private JMenu File = null;

	private JMenu info = null;

	private JMenuItem pInfo = null;

	private JMenuItem mOpen = null;

	private JToolBar jJToolBarBar = null;

	private JButton align = null;

	private JButton filter = null;

	private JButton measure = null;

	private File selectedImage = null; // @jve:decl-index=0:

	private File[] selectedImageSeries = null;

	private AorticRingStitch aorticRingStitch = null;

	private JMenu jMenu = null;

	private JMenuItem jMenuItem = null;

	private JCheckBox jCheckBox = null;

	private JMenuItem pHelp = null;

	private JMenuItem mQuit = null;

	private JButton jGetAcquire = null;

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
//			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getFile());
			jJMenuBar.add(getInfo());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes File
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getFile() {
		if (File == null) {
			File = new JMenu();
			File.setText("File");
			File.setMnemonic(KeyEvent.VK_F);
			File.add(getMOpen());
			File.addSeparator();
			File.add(getMQuit());
		}
		return File;
	}

	/**
	 * This method initializes info
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getInfo() {
		if (info == null) {
			info = new JMenu();
			info.setText("Help");
			info.setMnemonic(KeyEvent.VK_H);
			info.add(getPInfo());
			info.add(getPHelp());
		}
		return info;
	}

	/**
	 * This method initializes pInfo
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getPInfo() {
		if (pInfo == null) {
			pInfo = new JMenuItem();
			pInfo.setText("Info");
			pInfo.setMnemonic(KeyEvent.VK_I);
			pInfo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Info info = new Info();
				}
			});
		}
		return pInfo;
	}

	/**
	 * This method initializes mOpen
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getMOpen() {
		if (mOpen == null) {
			mOpen = new JMenuItem();
			mOpen.setText("Open Image / Images");
			mOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,ActionEvent.CTRL_MASK));
			mOpen.setMnemonic(KeyEvent.VK_O);
			mOpen.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setNull();
					JFileChooser sFile = new JFileChooser();
					MyFileFilter mf = new MyFileFilter("png");
					mf.addExtension("jpg");
					sFile.setFileFilter(mf);
					sFile.setMultiSelectionEnabled(true);
					sFile.showOpenDialog(new JFrame());
					if (selectedImage != null) {
						selectedImage = null;
					}
					if (selectedImageSeries != null) {
						selectedImageSeries = null;
					}
					selectedImageSeries = sFile.getSelectedFiles();
					if (selectedImageSeries != null
							&& selectedImageSeries.length > 1) {
						setButtons(2);
					} else if (selectedImageSeries != null
							&& selectedImageSeries.length == 1) {
						System.out.println("eine Datei geladen... ");
						selectedImage = selectedImageSeries[0];
						selectedImageSeries = null;
						setButtons(1);
					} else {
						setButtons(0);
					}
				}
			});
		}
		return mOpen;
	}

	/**
	 * This method initializes jJToolBarBar
	 * 
	 * @return javax.swing.JToolBar
	 */
	private JToolBar getJJToolBarBar() {
		if (jJToolBarBar == null) {
			jJToolBarBar = new JToolBar();
			try {
				// just to check wheter or not JMF is installed
				Class c = Class.forName("javax.media.CaptureDeviceInfo");
				System.out
						.println("Java Media Framework is installed on this computer");
				jJToolBarBar.add(getJGetAcquire());
			} catch (Exception e) {
				System.out
						.println("Java Media Framework is not installed on this computer");
			}
			jJToolBarBar.add(getStitch());
			jJToolBarBar.add(getFilter());
			jJToolBarBar.add(getMeasure());
			jJToolBarBar.add(getJCheckBox());
		}
		return jJToolBarBar;
	}

	/**
	 * This method initializes stitch
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getStitch() {
		if (align == null) {
			align = new JButton();
			align.setText("align");
			align.setEnabled(false);
			align.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					aorticRingStitch = null;
					if (aorticRingStitch == null) {
						aorticRingStitch = new AorticRingStitch(
								selectedImageSeries);
					}
				}
			});
		}
		return align;
	}

	/**
	 * This method initializes filter
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getFilter() {
		if (filter == null) {
			filter = new JButton();
			filter.setText("filter");
			filter.setEnabled(false);
			filter.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					FilterGauss filterGauss = null;
					if (selectedImage != null && selectedImageSeries == null) {
						filterGauss = new FilterGauss(100, 255, 20.0, 10.0,
								selectedImage, "filteredaaa");
					} else if (selectedImage == null
							&& selectedImageSeries != null) {
						filterGauss = new FilterGauss(100, 255, 20.0, 10.0,
								selectedImageSeries, "filteredaaa");
					} else {
						;
						// there must be something wrong
					}
				}

			});
		}
		return filter;
	}

	/**
	 * This method initializes measure
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getMeasure() {
		if (measure == null) {
			measure = new JButton();
			measure.setText("measure");
			measure.setEnabled(false);
			measure.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Measure aus = null;
					if (aus == null && selectedImageSeries != null) {
						aus = new Measure(selectedImageSeries);
					} else if (aus == null && selectedImage != null) {
						aus = new Measure(selectedImage);
					}
				}
			});
		}
		return measure;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
//	private JMenu getJMenu() {
//		if (jMenu == null) {
//			jMenu = new JMenu();
//			jMenu.setText("Acquire");
//		}
//		jMenu.setVisible(true);
//		System.out.println(System.getenv("classpath"));
//		try {
//			// just to check wheter or not JMF is installed
//			Class c = Class.forName("javax.media.CaptureDeviceInfo");
//			System.out
//					.println("Java Media Framework is installed on this computer");
//			jMenu.setVisible(true);
//			jMenu.add(getJMenuItem());
//		} catch (Exception e) {
//			System.out
//					.println("Java Media Framework is not installed on this computer");
//			jMenu.setVisible(false);
//		}
//		return jMenu;
//	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
//	private JMenuItem getJMenuItem() {
//		if (jMenuItem == null) {
//			jMenuItem = new JMenuItem();
//			jMenuItem.setText("grab images");
//			jMenuItem.addActionListener(new java.awt.event.ActionListener() {
//				public void actionPerformed(java.awt.event.ActionEvent e) {
//					System.out.println("application Grabber started");
//					MyGrabber mg = new MyGrabber();
//				}
//			});
//		}
//		return jMenuItem;
//	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("memory monitor");
			jCheckBox.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (jCheckBox.isSelected()) {
						mmm = new MyMemoryMonitor();
						mmmt = new Thread(mmm);
						mmmt.start();
						add(mmm);
						pack();
					} else {
						if (mmmt != null && mmm != null) {
							mmmt.interrupt();
							mmm.dispose();
						}
						pack();
					}
				}
			});
		}
		return jCheckBox;
	}

	/**
	 * This method initializes pHelp	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getPHelp() {
		if (pHelp == null) {
			pHelp = new JMenuItem();
			pHelp.setText("howto");
			pHelp.setMnemonic(KeyEvent.VK_W);
			pHelp.addActionListener(new java.awt.event.ActionListener() {   
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					MyHelpWindow mhw = new MyHelpWindow();
					mhw.setVisible(true);
				}
			
			});
		}
		return pHelp;
	}

	/**
	 * This method initializes mQuit	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getMQuit() {
		if (mQuit == null) {
			mQuit = new JMenuItem();
			mQuit.setText("Quit");
			mQuit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,ActionEvent.CTRL_MASK));
			mQuit.setMnemonic(KeyEvent.VK_Q);
			mQuit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.exit(0);
				}
			});
		}
		return mQuit;
	}

	/**
	 * This method initializes jGetAcquire	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJGetAcquire() {
		if (jGetAcquire == null) {
			jGetAcquire = new JButton();
			jGetAcquire.setText("acquire");
			jGetAcquire.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					MyGrabber mg = new MyGrabber();
				}
			});
		}
		return jGetAcquire;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Locale.setDefault(Locale.ENGLISH);
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				AQuaProg thisClass = new AQuaProg();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public AQuaProg() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle("AQuaL");
		this.setSize(new Dimension(274, 82));
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				if (mmmt != null && mmm != null) {
					mmmt.interrupt();
					mmm.dispose();
				}
				System.exit(0);
			}
		});
		this.pack();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJJToolBarBar(), BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * used by the file open dialog enables/disables the buttons
	 * 
	 * @param mode
	 *            1 = singleImage, 2 = multiImage, undefined = disable all
	 * @return void
	 */
	private void setButtons(int mode) {
		if (mode == 1) {
			// Buttons enabled if single Image selected
			align.setEnabled(false);
			filter.setEnabled(true);
			measure.setEnabled(true);
		} else if (mode == 2) {
			// Buttons enabled if multi Images selected
			align.setEnabled(true);
			filter.setEnabled(true);
			measure.setEnabled(true);
		} else {
			align.setEnabled(false);
			filter.setEnabled(false);
			measure.setEnabled(false);
		}
	}

	/**
	 * sets FileObjects to null
	 * 
	 */
	private void setNull() {
		selectedImage = null;
		selectedImageSeries = null;
	}
} // @jve:decl-index=0:visual-constraint="-2,-28"

class MyMemoryMonitor extends JInternalFrame implements Runnable {

	private static final long serialVersionUID = 1L;

	private long maxSpace = 0;
	private long actualSpace = 0;
	private long percentFree = 0;

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JLabel jLabel4 = null;

	private JLabel jLabel5 = null;

	/**
	 * This is the default constructor
	 */
	public MyMemoryMonitor() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		maxSpace = (Runtime.getRuntime().maxMemory() / 1048576);
		// this.setSize(247, 98);
		this.setClosable(true);
		this.setContentPane(getJContentPane());
		this.setTitle("memory");
		this.setVisible(true);
		pack();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.anchor = GridBagConstraints.EAST;
			gridBagConstraints7.gridy = 2;
			jLabel5 = new JLabel();
			jLabel5.setText("100");
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.anchor = GridBagConstraints.EAST;
			gridBagConstraints6.gridy = 0;
			jLabel4 = new JLabel();
			jLabel4.setText("0");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.anchor = GridBagConstraints.EAST;
			gridBagConstraints4.gridy = 2;
			jLabel3 = new JLabel();
			jLabel3.setText("available (%):");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.anchor = GridBagConstraints.EAST;
			gridBagConstraints3.gridy = 1;
			jLabel2 = new JLabel();
			jLabel2.setText(String.valueOf(maxSpace));
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridy = 1;
			jLabel1 = new JLabel();
			jLabel1.setText("maximum (MB):");
			jLabel1.setHorizontalAlignment(SwingConstants.LEADING);
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.anchor = GridBagConstraints.EAST;
			gridBagConstraints11.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints11.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("actual used memory (MB):");
			jLabel.setComponentOrientation(ComponentOrientation.UNKNOWN);
			jLabel.setHorizontalAlignment(SwingConstants.LEADING);
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(jLabel, gridBagConstraints11);
			jPanel.add(jLabel1, gridBagConstraints2);
			jPanel.add(jLabel2, gridBagConstraints3);
			jPanel.add(jLabel3, gridBagConstraints4);
			jPanel.add(jLabel4, gridBagConstraints6);
			jPanel.add(jLabel5, gridBagConstraints7);
		}
		return jPanel;
	}

	public void run() {
		while (true) {
			if (Thread.interrupted()) {
				System.out.println("und weg... ");
				break;
			}
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				;
			}
			actualSpace = (Runtime.getRuntime().freeMemory() / 1048576);
			// jTextField.setText(String.valueOf(actualSpace));
			jLabel4.setText(String.valueOf(actualSpace));
			percentFree = 100 - ((100 * actualSpace) / maxSpace);
			// jTextField1.setText(String.valueOf(percentFree));
			jLabel5.setText(String.valueOf(percentFree));
		}
	}
} // @jve:decl-index=0:visual-constraint="10,14"

class Info extends JWindow {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JButton jButton = null;

	private JTextPane jTextPane = null;

	/**
	 * This is the default constructor
	 */
	public Info() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(319, 118);
		Dimension sizeFrame = this.getSize();
		Dimension sizeScreen = this.getToolkit().getScreenSize();
		int loc_x = (int) (sizeScreen.getWidth() / 2)
				- (int) (sizeFrame.getWidth() / 2);
		int loc_y = (int) (sizeScreen.getHeight() / 2)
				- (int) (sizeFrame.getHeight() / 2);
		this.setLocation(new Point(loc_x, loc_y));
		this.setContentPane(getJContentPane());
		this.setVisible(true);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
			jContentPane.add(getJPanel1(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.gridx = 0;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(getJTextPane(), gridBagConstraints);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new Insets(6, 6, 6, 6);
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setBackground(Color.lightGray);
			jPanel1.add(getJButton(), gridBagConstraints1);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("ok");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jTextPane
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getJTextPane() {
		if (jTextPane == null) {
			jTextPane = new JTextPane();
			jTextPane.setBackground(Color.lightGray);
			jTextPane.setFont(new Font("Comic Sans MS", Font.PLAIN, 14));
			jTextPane.setEditable(false);
			jTextPane.setText("AQuaL: Angiogenesis quantification; Luebeck");
		}
		return jTextPane;
	}

} // @jve:decl-index=0:visual-constraint="10,10"

class MyFileFilter extends FileFilter {

	Vector<String> extensions = new Vector<String>();

	public MyFileFilter(String ex) {
		if (ex.indexOf('.') != -1) {
			ex = ex.substring(ex.lastIndexOf('.') + 1);
		}
		ex = ex.toLowerCase();
		extensions.add(ex);
	}

	public void addExtension(String ex) {
		if (ex.indexOf('.') != -1) {
			ex = ex.substring(ex.lastIndexOf('.') + 1);
		}
		ex = ex.toLowerCase();
		extensions.add(ex);
	}

	@Override
	public boolean accept(File arg0) {
		if (arg0.isDirectory()) {
			return true;
		}
		String ex = arg0.getName().substring(
				arg0.getName().lastIndexOf('.') + 1);
		ex = ex.toLowerCase();
		if (extensions.contains(ex)) {
			return true;
		}
		return false;
	}

	@Override
	public String getDescription() {
		return "jpg, png";
	}
}

class MyHelpWindow extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel jCloseWindow = null;
	private JButton jCloseWindowButton = null;
	private JEditorPane jHelpPage = null;
	private JScrollPane jScrollPane = null;

	/**
	 * This is the default constructor
	 */
	public MyHelpWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(403, 521);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle("help");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJCloseWindow(), BorderLayout.SOUTH);
			jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jCloseWindow	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJCloseWindow() {
		if (jCloseWindow == null) {
			jCloseWindow = new JPanel();
			jCloseWindow.setLayout(new GridBagLayout());
			jCloseWindow.add(getJCloseWindowButton(), new GridBagConstraints());
		}
		return jCloseWindow;
	}

	/**
	 * This method initializes jCloseWindowButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJCloseWindowButton() {
		if (jCloseWindowButton == null) {
			jCloseWindowButton = new JButton();
			jCloseWindowButton.setText("close");
			jCloseWindowButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jCloseWindowButton;
	}

	/**
	 * This method initializes jHelpPage	
	 * 	
	 * @return javax.swing.JEditorPane	
	 */
	private JEditorPane getJHelpPage() {
		if (jHelpPage == null) {
			jHelpPage = new JEditorPane();
			jHelpPage.setContentType("text/html");
			String s = null;
			URL helpFile = null;
			s = "file:AQuaL.html";
			try {
				helpFile = new URL(s);
			} catch (MalformedURLException e) {
				e.printStackTrace();
			}
			try {
				jHelpPage.setPage(helpFile);
				jHelpPage.setEditable(false);
			} catch (IOException e) {
				System.out.println("unable to display howto");
				e.printStackTrace();
			}
			
			
		}
		return jHelpPage;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJHelpPage());
		}
		return jScrollPane;
	}

}
