import java.io.File;
import java.io.IOException;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.JComponent;
import javax.swing.JScrollBar;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JCheckBox;
import javax.swing.WindowConstants;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Image;
import java.awt.Insets;
import java.awt.MediaTracker;
import java.awt.geom.AffineTransform;
import java.awt.image.PixelGrabber;
import java.awt.image.RenderedImage;

import javax.swing.JLabel;

/**
 * Created on 04.03.2005
 * 
 * @author Markus Bttcher
 */
public class AorticRingStitch extends JFrame {
	private static final long serialVersionUID = 1L;

	AlignImages alg = null;

	// Prefix of the aligned file
	private String filePrefix = "aligned"; // @jve:decl-index=0:

	// locate frames on desktop
	int screenWidth = 0;

	int screenHeight = 0;

	int windowWidth = 0;

	Vector<MyFileInfo> fileInfo = null; // @jve:decl-index=0:

	// contains the name of the actual source and target image
	MyFileInfo mfi = null;

	private int prev_selec = -1;

	private int prev_selec2 = -1;

	// selection of list elements are fired twice...
	// variable ps is used to react on single events
	private boolean ps = false;

	private JScrollBar targethor = null;

	private JScrollBar targetver = null;

	private MyStitch mystitch = null;

	private MyVektor result = null;

	private File[] bilder = null;

	private javax.swing.JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JList jList1 = null;

	private JScrollPane jScrollPane1 = null;

	private MyFrame sourceImg = null;

	private MyFrame targetImg = null;

	private JCheckBox jCheckBox = null;

	private JCheckBox jCheckBox1 = null;

	private JButton jButton1 = null;

	private JButton removeLast = null;

	private JPanel jPanel1 = null;

	private JLabel jLabel = null;

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.gridy = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.gridx = 1;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.setPreferredSize(new Dimension(150, 60));
			jPanel.add(getJButton1(), gridBagConstraints2);
			jPanel.add(getRemoveLast(), gridBagConstraints11);
		}
		return jPanel;
	}

	/**
	 * This method initializes jList1
	 * 
	 * @return javax.swing.JList
	 */
	private JList getJList1() {
		if (jList1 == null) {
			jList1 = new JList();
			jList1.setSize(new Dimension(100, 100));
			jList1
					.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jList1
					.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
						public void valueChanged(
								javax.swing.event.ListSelectionEvent e) {
							removeLast.setEnabled(false);
							jButton1.setEnabled(false);
							// display the selected images
							try {
								if (ps == false) {
									if (prev_selec >= 0 && prev_selec2 >= 0) {
										if (mfi != null) {
											mfi = null;
										}
										if (mfi == null) {
											mfi = new MyFileInfo();
										}
										if (sourceImg == null) {
											sourceImg = new MyFrame(
													"source image");
											int w = screenWidth - windowWidth;
											sourceImg.setSize(w,
													screenHeight / 2);
											sourceImg.setLocation(windowWidth,
													0);
										}
										jCheckBox.setSelected(false);
										sourceImg.setImage(bilder[prev_selec]
												.getCanonicalPath());
										mfi.setNameSource(bilder[prev_selec]
												.getCanonicalPath());
										sourceImg.setJCheckBox(jCheckBox);
										sourceImg.toFront();
										sourceImg.repaint();

										if (targetImg == null) {
											targetImg = new MyFrame(
													"target image");
											int w = screenWidth - windowWidth;
											targetImg.setSize(w,
													screenHeight / 2);
											targetImg.setLocation(windowWidth,
													screenHeight / 2);
										}
										jCheckBox1.setSelected(false);
										prev_selec2 = jList1.getSelectedIndex();
										mfi.setNameTarget(bilder[prev_selec2]
												.getCanonicalPath());
										targetImg.setImage(bilder[prev_selec2]
												.getCanonicalPath());
										targetImg.setJCheckBox(jCheckBox1);
										targetImg.toFront();
										targetImg.repaint();
										prev_selec = prev_selec2;
										System.out.println("pre nach "
												+ prev_selec);
									} else {
										if (sourceImg == null) {
											sourceImg = new MyFrame(
													"source image");
											int w = screenWidth - windowWidth;
											sourceImg.setSize(w,
													screenHeight / 2);
											sourceImg.setLocation(windowWidth,
													0);
										}
										jCheckBox.setSelected(false);
										prev_selec = jList1.getSelectedIndex();
										sourceImg.setImage(bilder[prev_selec]
												.getAbsolutePath());
										sourceImg.setJCheckBox(jCheckBox);
										sourceImg.toFront();
										sourceImg.repaint();
										prev_selec2 = prev_selec;
									}
									ps = true;
								} else {
									ps = false;
								}
							} catch (IOException e2) {
								;
							}

						}
					});
		}
		return jList1;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJList1());

			if (targethor == null) {
				targethor = jScrollPane1.getHorizontalScrollBar();
			}

			if (targetver == null) {
				targetver = jScrollPane1.getVerticalScrollBar();
			}
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("source image");
			jCheckBox.setEnabled(false);
			jCheckBox.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (jCheckBox.isSelected() && jCheckBox1.isSelected()) {
						setValues();
					}
				}
			});
		}
		return jCheckBox;
	}

	/**
	 * This method initializes jCheckBox1
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("target image");
			jCheckBox1.setEnabled(false);
			jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (jCheckBox.isSelected() && jCheckBox1.isSelected()) {
						setValues();
					}
				}
			});
		}
		return jCheckBox1;
	}

	private void setValues() {
		// save the obtained translation values of the linked images
		if (fileInfo == null) {
			fileInfo = new Vector<MyFileInfo>();
		}
		if (mystitch == null) {
			mystitch = new MyStitch();
		}
		mystitch.setPositionSource(sourceImg.getSelectedX(), sourceImg
				.getSelectedY());
		mystitch.setPositionTarget(targetImg.getSelectedX(), targetImg
				.getSelectedY());
		result = mystitch.align_manual();
		mfi.setTranslationX(result.getX());
		mfi.setTranslationY(result.getY());
		// save original pixel coordinates...
		mfi.setPosX_Source(sourceImg.getSelectedX());
		mfi.setPosY_Source(sourceImg.getSelectedY());
		mfi.setPosX_Target(targetImg.getSelectedX());
		mfi.setPos_Y_Target(targetImg.getSelectedY());
		fileInfo.add(mfi);
		// enable Buttons for undo and align
		removeLast.setEnabled(true);
		jButton1.setEnabled(true);
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("generate composite image");
			jButton1.setEnabled(false);
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (!alg.isVisible()) {
						alg.setVisible(true);
					}
					alg.setFilePrefix(filePrefix);
					alg.alignAllFiles(fileInfo);
					alg.repaint();
					setNull();
				}
			});
		}
		return jButton1;
	}

	/**
	 * This is the default constructor
	 */
	public AorticRingStitch(File[] images) {
		super();
		bilder = images;
		initialize();
		setVisible(true);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setPreferredSize(new Dimension(350, 350));
		this.setSize(new Dimension(390, 340));
		this.setContentPane(getJContentPane());
		this.setTitle("image alignment");
		jList1.setListData(bilder);
		this.pack();
		screenWidth = this.getToolkit().getScreenSize().width;
		screenHeight = this.getToolkit().getScreenSize().height;
		this.setSize(390, screenHeight / 2);
		windowWidth = this.getWidth();
		alg = new AlignImages();
		alg.setLocation(0, getSize().height);
		alg.setSize(this.getSize());

		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.out.println("windowClosing()"); // TODO Auto-generated
				if (sourceImg != null) {
					sourceImg.dispose();
				}
				if (targetImg != null) {
					targetImg.dispose();
				}
				alg.dispose();
				dispose();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.NORTH);
			jContentPane.add(getJScrollPane1(), BorderLayout.CENTER);
			jContentPane.add(getJPanel1(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes removeLast
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getRemoveLast() {
		if (removeLast == null) {
			removeLast = new JButton();
			removeLast.setText("remove last pair");
			removeLast.setEnabled(false);
			removeLast.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (fileInfo != null && fileInfo.size() > 0) {
						fileInfo.remove(fileInfo.size() - 1);
					} else {
						;
					}
					removeLast.setEnabled(false);
					jCheckBox.setSelected(false);
					jCheckBox1.setSelected(false);
				}
			});
		}
		return removeLast;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("value accepted:");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.gridx = 2;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 1;
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.add(getJCheckBox(), gridBagConstraints);
			jPanel1.add(getJCheckBox1(), gridBagConstraints1);
			jPanel1.add(jLabel, gridBagConstraints3);
		}
		return jPanel1;
	}

	/**
	 * induces the construction of a new alignment... used by the Button align
	 */
	private void setNull() {
		prev_selec = -1;
		prev_selec2 = -1;
		ps = false;
		if (fileInfo != null) {
			fileInfo = null;
		}
	}

	/**
	 * @return the filePrefix
	 */
	public String getFilePrefix() {
		return filePrefix;
	}

	/**
	 * @param filePrefix
	 *            the filePrefix to set
	 */
	public void setFilePrefix(String filePrefix) {
		this.filePrefix = filePrefix;
	}
} // @jve:decl-index=0:visual-constraint="10,10"

class MyStitch extends JScrollPane {
	private static final long serialVersionUID = 1L;
	/**
	 * position of the selected point in image 1
	 */
	private int selectedXFrame1 = 0;
	private int selectedYFrame1 = 0;

	/**
	 * position of the selected point in image 2
	 */
	private int selectedXFrame2 = 0;
	private int selectedYFrame2 = 0;

	public MyStitch() {
		;
	}

	public void setPositionSource(int x, int y) {
		selectedXFrame1 = x;
		selectedYFrame1 = y;
	}

	public void setPositionTarget(int x, int y) {
		selectedXFrame2 = x;
		selectedYFrame2 = y;
	}

	public MyVektor align_manual() {
		int resultx = this.selectedXFrame1 - this.selectedXFrame2;
		int resulty = this.selectedYFrame1 - this.selectedYFrame2;
		return new MyVektor(resultx, resulty);
	}
}

class AlignImages extends JFrame {

	private static final long serialVersionUID = 1L;

	private boolean calculateAbsoluteDifference = true;

	private int radius_Source = 15;

	private int radius_Target_xtimes = 2;

	double scale = 1.0;

	int previewWidth = 0;

	int previewHeight = 0;

	int pImageWidth = 0;

	int pImageHeight = 0;

	AffineTransform aT = null; // @jve:decl-index=0:

	Graphics2D g2d = null;

	private String filePrefix = "a"; // @jve:decl-index=0:

	// informations of the linked images
	private Vector<MyFileInfo> fileInfo = null; // @jve:decl-index=0:

	private MyFileInfo mfi = null;

	// saves informations of all images
	private Vector<MyImage> images = new Vector<MyImage>(); // @jve:decl-index=0:

	private MyVektor translationAllImages = null; // @jve:decl-index=0:

	private int dx_min = 0;

	private int dx_max = 0;

	private int dy_min = 0;

	private int dy_max = 0;

	// dimension of the aligned image
	private int newImageWidth = 0;

	private int newImageHeight = 0;

	// the actual image
	private Image actualImage = null; // @jve:decl-index=0:

	// name of the aligned image
	private String resultImage = null;

	private Image sourceImage = null;

	private int sourceImageWidth = 0;

	private int sourceImageHeight = 0;

	private Image targetImage = null; // @jve:decl-index=0:

	private int targetImageWidth = 0;

	private int targetImageHeight = 0;

	// object to calculate the aligned image
	private Image saveImage = null; // @jve:decl-index=0:

	private Graphics saveGraphics = null;

	private javax.swing.JPanel jContentPane = null;

	private MyPreviewPanel jPanel1 = null;

	private JScrollPane jScrollPane = null;

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private MyPreviewPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new MyPreviewPanel();
		}
		return jPanel1;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJPanel1());
		}
		return jScrollPane;
	}

	// public static void main(String[] args) {
	// AlignImages a = new AlignImages();
	// }

	/**
	 * This is the default constructor
	 */
	public AlignImages() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle("aligned image");
		this.setVisible(true);
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				// System.exit(0);
				;
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * 
	 * @param image
	 *            image name
	 */
	public void setSourceImage(String image) {
		sourceImage = null;
		sourceImage = this.getToolkit().getImage(image);
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(sourceImage, 0);
		try {
			mt.waitForAll();
		} catch (InterruptedException e) {
			;
		}
		sourceImageWidth = sourceImage.getWidth(this);
		sourceImageHeight = sourceImage.getHeight(this);
	}

	public void setTargetImage(String image) {
		targetImage = null;
		targetImage = this.getToolkit().getImage(image);
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(targetImage, 0);
		try {
			mt.waitForAll();
		} catch (InterruptedException e) {
			;
		}
		targetImageWidth = targetImage.getWidth(this);
		targetImageHeight = targetImage.getHeight(this);
	}

	// loads the actually needed image
	public void loadImage(String image) {
		actualImage = null;
		actualImage = this.getToolkit().getImage(image);
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(actualImage, 0);
		try {
			mt.waitForAll();
		} catch (InterruptedException e) {
			;
		}
	}

	// draw the aligned image
	public void alignAllImages() {
		newImageWidth = Math.abs(dx_min) + Math.abs(dx_max);
		newImageHeight = Math.abs(dy_min) + Math.abs(dy_max);
		saveImage = null;

		if (saveImage == null) {
			saveImage = this.createImage(newImageWidth, newImageHeight);
			MediaTracker mt = new MediaTracker(this);
			mt.addImage(saveImage, 0);
			try {
				mt.waitForAll();
			} catch (InterruptedException e) {
				;
			}
			saveGraphics = saveImage.getGraphics();

			// fill the image with the background color
			saveGraphics.setColor(new Color(125, 125, 125));
			saveGraphics.fillRect(0, 0, newImageWidth, newImageHeight);
		}
		// translation of the images according to the aligned image dimensions
		translationAllImages = new MyVektor((-1 * dx_min), (-1 * dy_min));
		for (int i = 0; i < images.size(); i++) {
			MyImage image = images.elementAt(i);

			// translation of each image according to the aligned image
			// dimension
			MyVektor translationImage = image.getTranslation();

			translationImage.vectorAdd(translationAllImages);

			loadImage(image.getImage());
			// draw into the aligned image
			saveGraphics.drawImage(actualImage, translationImage.getX(),
					translationImage.getY(), this);
		}
		// // just to draw the borders of the individual images
		// // this block should be removed later on...
		// for (int i = 0; i < images.size(); i++) {
		// MyImage image = (MyImage) images.elementAt(i);
		// MyVektor translationImage = image.getTranslation();
		// loadImage(image.getImage());
		// saveGraphics.setColor(Color.WHITE);
		// for (int j = 0; j < 10; j++) {
		// saveGraphics.drawRect(translationImage.getX() + j,
		// translationImage.getY() + j, (actualImage
		// .getWidth(this) - 2 * j), (actualImage
		// .getHeight(this) - 2 * j));
		// }
		// }
	}

	// save the aligned image
	public void saveResultImage(String s) {
		File file = new File(s);
		String savefile = file.getParent() + File.separator + filePrefix
				+ file.getName();
		try {
			ImageIO.write((RenderedImage) saveImage, "png", new File(savefile));
			System.out.println("Datei wurde erstellt");
		} catch (IOException ioe) {
			System.out.println("Bild konnte nicht erstellt werden...");
		}
	}

	// convert RGB-data to grayscale-values
	private void convertToGrayscale(int[] c) {
		float blue = 0.0f;
		float red = 0.0f;
		float green = 0.0f;
		float gray = 0.0f;
		for (int i = 0; i < c.length; i++) {
			gray = 0.0f;
			blue = (c[i]) & 0xff;
			green = (c[i] >> 8) & 0xff;
			red = (c[i] >> 16) & 0xff;
			gray = red * 0.2125f + green * 0.7154f + blue * 0.072f;
			c[i] = Math.round(gray);
		}
	}

	public void alignAllFiles(Vector<MyFileInfo> fileInfo) {
		this.fileInfo = fileInfo;
		// calculate the dimensions of the aligned image
		// calculate the resulting translation of each image
		try {
			String sourceImageName = null;
			String targetImageName = null;
			// resulting translation
			MyVektor resultierende = new MyVektor(0, 0);

			// translation of the target image according to the source image
			MyVektor translation = null;
			int dx = 0;
			int dy = 0;

			for (int i = 0; i < fileInfo.size(); i++) {
				mfi = fileInfo.elementAt(i);
				System.out.println(mfi.toString());
				sourceImageName = mfi.getNameSource();
				setSourceImage(sourceImageName);
				targetImageName = mfi.getNameTarget();
				setTargetImage(targetImageName);

				// calculation of the absolute difference to adjust the linked
				// images
				if (calculateAbsoluteDifference) {
					Image sImage = null;
					Image tImage = null;
					sImage = this.getToolkit().getImage(sourceImageName);
					tImage = this.getToolkit().getImage(targetImageName);
					MediaTracker mt = new MediaTracker(this);
					mt.addImage(sImage, 0);
					mt.addImage(tImage, 0);
					try {
						mt.waitForAll();
					} catch (InterruptedException e) {
						;
					}
					// dimensions of the arrays containing pixel values
					int s_width = radius_Source * 2 + 1;
					int s_height = radius_Source * 2 + 1;
					int t_width = radius_Source * 2 * radius_Target_xtimes + 1;
					int t_height = radius_Source * 2 * radius_Target_xtimes + 1;
					int[] pixels_source = new int[s_width * s_height];
					int[] pixels_target = new int[t_width * t_height];
					// grab pixel-values
					PixelGrabber pg_source = new PixelGrabber(sImage, mfi
							.getPosX_Source()
							- radius_Source - 1, mfi.getPosY_Source()
							- radius_Source - 1, s_width, s_height,
							pixels_source, 0, s_width);
					PixelGrabber pg_target = new PixelGrabber(tImage, mfi
							.getPosX_Target()
							- (radius_Source * radius_Target_xtimes) - 1, mfi
							.getPos_Y_Target()
							- (radius_Source * radius_Target_xtimes) - 1,
							t_width, t_height, pixels_target, 0, t_width);
					try {
						pg_source.grabPixels();
						pg_target.grabPixels();
						// convert RGB- into grayscale values
						convertToGrayscale(pixels_source);
						convertToGrayscale(pixels_target);

						// moving through the target field
						// actIinS = actual index in the source image
						int actIinS = 0;
						int actIinT = 0;

						// mean-difference
						double result_sad = 0.0;
						// euclidic distance
						double result_eD = 0.0;
						int resultX = 0;
						int resultY = 0;
						boolean first_run = true;

						for (int tx = 0; tx < t_width - s_width; tx++) {
							for (int ty = 0; ty < t_height - s_height; ty++) {
								// calculating
								// double sad = 0.0;
								double euclidicD = 0.0; // normalised euclidic
								// distance
								for (int sx = 0; sx < s_width; sx++) {
									for (int sy = 0; sy < s_height; sy++) {
										actIinS = sy * s_width + sx;
										actIinT = (ty + sy) * t_width + tx + sx;
										// sad = sad
										// + Math
										// .sqrt(((double)
										// pixels_target[actIinT] - (double)
										// pixels_source[actIinS])
										// * ((double) pixels_target[actIinT] -
										// (double) pixels_source[actIinS]));
										euclidicD = euclidicD
												+ Math
														.pow(
																((double) pixels_target[actIinT] - (double) pixels_source[actIinS]),
																2.0);
									}
								}
								if (first_run) {
									// result_sad = sad;
									result_eD = Math.sqrt(euclidicD);
									resultX = tx;
									resultY = ty;
								} else {
									// if (result_sad <= sad) {
									// ;
									// } else {
									// result_sad = sad;
									// resultX = tx;
									// resultY = ty;
									// }
									if (result_eD <= Math.sqrt(euclidicD)) {
										;
									} else {
										result_eD = Math.sqrt(euclidicD);
										resultX = tx;
										resultY = ty;
									}

								}
								first_run = false;
							}
						}
						int vx = resultX + radius_Source + 1;
						int vy = resultY + radius_Source + 1;

						int wx = radius_Source * radius_Target_xtimes + 1;
						int wy = radius_Source * radius_Target_xtimes + 1;

						int rx = wx - vx;
						int ry = wy - vy;

						// change the translation obtained via mouse click to
						// to the calculated values
						mfi.setTranslationX(mfi.getTranslationX() + rx);
						mfi.setTranslationY(mfi.getTranslationY() + ry);
					} catch (InterruptedException e) {
						System.err.println("interrupted waiting for pixels!");
					}
					sImage = null;
					tImage = null;
					pg_source = null;
					pg_target = null;
					pixels_source = null;
					pixels_target = null;
					System.gc();
				}
				dx = mfi.getTranslationX();
				dy = mfi.getTranslationY();
				translation = new MyVektor(dx, dy);

				if (i == 0) {
					// set the name of the result image
					resultImage = sourceImageName;
					images
							.addElement(new MyImage(sourceImageName,
									sourceImageWidth, sourceImageHeight,
									new MyVektor(resultierende.getX(),
											resultierende.getY())));

					// during the first step the source image has to be included
					int dx_min_temp = resultierende.getX();
					if (dx_min_temp < dx_min) {
						dx_min = dx_min_temp;
					}
					int dx_max_temp = resultierende.getX() + sourceImageWidth;
					if (dx_max_temp > dx_max) {
						dx_max = dx_max_temp;
					}

					int dy_min_temp = resultierende.getY();
					if (dy_min_temp < dy_min) {
						dy_min = dy_min_temp;
					}

					int dy_max_temp = resultierende.getY() + sourceImageHeight;
					if (dy_max_temp > dy_max) {
						dy_max = dy_max_temp;
					}
					resultierende.vectorAdd(translation);
					images
							.addElement(new MyImage(targetImageName,
									targetImageWidth, targetImageHeight,
									new MyVektor(resultierende.getX(),
											resultierende.getY())));
				} else {
					resultierende.vectorAdd(translation);
					images
							.addElement(new MyImage(targetImageName,
									targetImageWidth, targetImageHeight,
									new MyVektor(resultierende.getX(),
											resultierende.getY())));
				}
				int dx_min_temp = resultierende.getX();
				if (dx_min_temp < dx_min) {
					dx_min = dx_min_temp;
				}
				int dx_max_temp = resultierende.getX() + targetImageWidth;
				if (dx_max_temp > dx_max) {
					dx_max = dx_max_temp;
				}
				int dy_min_temp = resultierende.getY();
				if (dy_min_temp < dy_min) {
					dy_min = dy_min_temp;
				}
				int dy_max_temp = resultierende.getY() + targetImageHeight;
				if (dy_max_temp > dy_max) {
					dy_max = dy_max_temp;
				}
			}
			// generate the aligned image
			alignAllImages();
			// save the aligned image
			saveResultImage(resultImage);
			// visualize the aligned image
			jPanel1.setImage(saveImage);

			// reset values of the used variables
			newImageWidth = 0;
			newImageHeight = 0;
			translationAllImages = null;
			dx_min = 0;
			dx_max = 0;
			dy_min = 0;
			dy_max = 0;

			images = new Vector<MyImage>();
			sourceImageName = null;
			targetImageName = null;
			resultierende = new MyVektor(0, 0);
			translation = null;
			dx = 0;
			dy = 0;
		} catch (Exception config_in) {
			System.out.println(config_in.getStackTrace());
		}
	}

	/**
	 * @param fileInfo
	 *            the fileInfo to set
	 */
	public void setFileInfo(Vector<MyFileInfo> fileInfo) {
		this.fileInfo = fileInfo;
	}

	/**
	 * @return the filePrefix
	 */
	public String getFilePrefix() {
		return filePrefix;
	}

	/**
	 * @param filePrefix
	 *            the filePrefix to set
	 */
	public void setFilePrefix(String filePrefix) {
		this.filePrefix = filePrefix;
	}
} // @jve:decl-index=0:visual-constraint="10,10"
// Panel to visualize the aligned image

class MyPreviewPanel extends JComponent {
	private static final long serialVersionUID = 1L;

	private double aspectW = 0.0;

	private double aspectI = 0.0;

	private Image prevImage = null;

	private Image showImage = null;

	int previewWidth = 0;

	int previewHeight = 0;

	int pImageWidth = 0;

	int pImageHeight = 0;

	double scale = 1.0;

	Graphics2D g2d = null;

	MyPreviewPanel() {
		;
	}

	@Override
	public void paintComponent(Graphics g) {
		genImage();
		if (showImage != null) {
			g.drawImage(showImage, 0, 0, this);
		}
	}

	public void setImage(Image prev) {
		this.prevImage = prev;
		pImageWidth = prevImage.getWidth(this);
		pImageHeight = prevImage.getHeight(this);
		this.repaint();
	}

	public void genImage() {
		if (prevImage != null) {
			previewWidth = this.getWidth();
			previewHeight = this.getHeight();
			showImage = createImage(previewWidth, previewHeight);
			aspectW = (double) previewWidth / (double) previewHeight;
			aspectI = (double) pImageWidth / (double) pImageHeight;
			if (aspectI >= aspectW) {
				scale = 1.0 / pImageWidth * previewWidth;
			} else {
				scale = 1.0 / pImageHeight * previewHeight;
			}
			AffineTransform aT = new AffineTransform();
			aT.scale(scale, scale);
			g2d = (Graphics2D) showImage.getGraphics();
			g2d.setTransform(aT);
			g2d.drawImage(prevImage, 0, 0, this);
		}
	}
}

class MyImage {
	private String image = null;
	private int imageWidth = 0;
	private int imageHeight = 0;
	private MyVektor translation = null;

	public MyImage(String imageName, int imageWidth, int imageHeight,
			MyVektor translation) {
		this.image = imageName;
		this.imageWidth = imageWidth;
		this.imageHeight = imageHeight;
		this.translation = translation;
	}

	/**
	 * @return Returns the image. The full path of the image is returned
	 */
	public String getImage() {
		return image;
	}

	/**
	 * @return Returns the imageHeight.
	 */
	public int getImageHeight() {
		return imageHeight;
	}

	/**
	 * @return Returns the imageWidth.
	 */
	public int getImageWidth() {
		return imageWidth;
	}

	/**
	 * @return Returns the translation.
	 */
	public MyVektor getTranslation() {
		return translation;
	}

	public void showInfo() {
		System.out.println("Name: " + image);
		System.out.println("width " + imageWidth + " height " + imageHeight
				+ " dx= " + translation.getX() + " dy= " + translation.getY()
				+ "\n");
	}
}

class MyFileInfo {
	private String nameSource = null;

	private String nameTarget = null;

	private int translationX = 0;

	private int translationY = 0;

	private int posX_Source = 0;

	private int posY_Source = 0;

	private int posX_Target = 0;

	private int pos_Y_Target = 0;

	/**
	 * @return the translationX
	 */
	public int getTranslationX() {
		return translationX;
	}

	/**
	 * @param translationX
	 *            the translationX to set
	 */
	public void setTranslationX(int translationX) {
		this.translationX = translationX;
	}

	/**
	 * @return the translationY
	 */
	public int getTranslationY() {
		return translationY;
	}

	/**
	 * @param translationY
	 *            the translationY to set
	 */
	public void setTranslationY(int translationY) {
		this.translationY = translationY;
	}

	public MyFileInfo() {
		;
	}

	/**
	 * @return the nameSource
	 */
	public String getNameSource() {
		return nameSource;
	}

	/**
	 * @param nameSource
	 *            the nameSource to set
	 */
	public void setNameSource(String nameSource) {
		this.nameSource = nameSource;
	}

	/**
	 * @return the nameTarget
	 */
	public String getNameTarget() {
		return nameTarget;
	}

	/**
	 * @param nameTarget
	 *            the nameTarget to set
	 */
	public void setNameTarget(String nameTarget) {
		this.nameTarget = nameTarget;
	}

	@Override
	public String toString() {
		return this.nameSource + " " + this.nameTarget + " "
				+ this.translationX + " " + this.translationY + " "
				+ this.posX_Source + " " + this.posY_Source + " "
				+ this.posX_Target + " " + this.pos_Y_Target;
	}

	public int getPosX_Source() {
		return posX_Source;
	}

	public void setPosX_Source(int posX_Source) {
		this.posX_Source = posX_Source;
	}

	public int getPosY_Source() {
		return posY_Source;
	}

	public void setPosY_Source(int posY_Source) {
		this.posY_Source = posY_Source;
	}

	public int getPosX_Target() {
		return posX_Target;
	}

	public void setPosX_Target(int posX_Target) {
		this.posX_Target = posX_Target;
	}

	public int getPos_Y_Target() {
		return pos_Y_Target;
	}

	public void setPos_Y_Target(int pos_Y_Target) {
		this.pos_Y_Target = pos_Y_Target;
	}
}

class MyVektor {
	int x = 0;
	int y = 0;

	public MyVektor(int x, int y) {
		this.x = x;
		this.y = y;
	}

	/**
	 * @return Returns the x.
	 */
	public int getX() {
		return x;
	}

	/**
	 * @return Returns the y.
	 */
	public int getY() {
		return y;
	}

	/**
	 * Die Addition weier Vektoren
	 * 
	 * @param a
	 *            Vektor a
	 * @param b
	 *            Vektor b
	 * @return VektorA+VektorB
	 */
	public MyVektor vectorAdd(MyVektor a, MyVektor b) {
		return new MyVektor(a.getX() + b.getX(), a.getY() + b.getY());
	}

	public void vectorAdd(MyVektor trans) {
		this.x = this.x + trans.getX();
		this.y = this.y + trans.getY();
	}
}
