import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import java.awt.GridBagConstraints;

import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;
import javax.swing.JSlider;
import java.awt.Dimension;
import javax.swing.JTextField;
import java.io.File;
import javax.swing.JLabel;
import java.awt.Insets;
import java.awt.Color;
import javax.swing.JCheckBox;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.SwingConstants;
import java.awt.ComponentOrientation;

/**
 * @author Markus Bttcher image filters are implemented in MyPanel that is
 *         referenced in MyFrame FilterGauss is the user interface
 */
public class FilterGauss extends JFrame {

	private static final long serialVersionUID = 1L;

	int numberOfImages = 0;

	int indexActualImage = 0;

	File images = null;

	File[] imagesSeries = null;

	private boolean single_image_mode = false;

	private String filteredImagePrefix = "filtered"; // @jve:decl-index=0:

	private double filter_radius = 10.0;

	private double filter_sigma = 0.2;

	private int threshold_min = 140;

	private int threshold_max = 255;

	int screenWidth = 0;

	int screenHeight = 0;

	int windowHeight = 0;

	private String filteredImageName = null; // @jve:decl-index=0:

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JButton jButton = null;

	private MyFrame filtered = null;

	private MyFrame original = null;

	private JButton jButton1 = null;

	private JPanel jPanel1 = null;

	private JSlider jSlider = null;

	private JButton jButton2 = null;

	private JButton jButton3 = null;

	private JSlider jSlider1 = null;

	private JTextField jTextField = null;

	private JTextField jTextField1 = null;

	private JTextField jTextField2 = null;

	private JTextField jTextField3 = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JButton jButton4 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JButton jSkeletonize = null;

	private JButton jButton5 = null;

	private JButton jButton6 = null;

	private JButton jButton7 = null;

	private JCheckBox jCheckBox = null;

	private JButton jButton8 = null;

	private JMenuBar jJMenuBar = null;

	private JMenu jMenu = null;

	private JPanel jPanel11 = null;

	private JLabel jLabel4 = null;

	private JTextField jTextField4 = null;

	private JLabel jLabel11 = null;

	private JTextField jTextField11 = null;

	private JTextField jTextField21 = null;

	private JTextField jTextField31 = null;

	private JButton jButton21 = null;

	private JCheckBox jHistogram = null;

	private JLabel jXAxis = null;

	private JLabel jYAxis = null;

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 9;
			gridBagConstraints15.insets = new Insets(0, 20, 0, 0);
			gridBagConstraints15.gridy = 0;
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 8;
			gridBagConstraints19.insets = new Insets(0, 20, 0, 0);
			gridBagConstraints19.gridy = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("sigma:");
			jLabel = new JLabel();
			jLabel.setText("radius:");

			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 6;
			gridBagConstraints18.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints18.gridy = 0;
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 4;
			gridBagConstraints17.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints17.gridy = 0;
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 5;
			gridBagConstraints16.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints16.gridy = 0;
			jLabel3 = new JLabel();
			jLabel3.setText("lower:");
			jLabel2 = new JLabel();
			jLabel2.setText("upper:");
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.gridx = 1;
			gridBagConstraints22.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 0;
			gridBagConstraints14.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints14.gridy = 0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 3;
			gridBagConstraints12.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints12.gridy = 0;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 7;
			gridBagConstraints11.insets = new Insets(0, 20, 0, 0);
			gridBagConstraints11.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.insets = new Insets(0, 20, 0, 0);
			gridBagConstraints.gridy = 0;

			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.setBorder(new SoftBevelBorder(BevelBorder.RAISED));
			jPanel.add(getJButton(), gridBagConstraints22);
			jPanel.add(getJButton1(), gridBagConstraints);
			jPanel.add(getJButton2(), gridBagConstraints11);
			jPanel.add(getJButton3(), gridBagConstraints12);
			jPanel.add(getJButton4(), gridBagConstraints14);
			jPanel.add(getJSkeletonize(), gridBagConstraints16);
			jPanel.add(getJButton5(), gridBagConstraints17);
			jPanel.add(getJButton6(), gridBagConstraints18);
			jPanel.add(getJButton7(), gridBagConstraints19);
			jPanel.add(getJButton8(), gridBagConstraints15);
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("next");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					;
					if (indexActualImage < numberOfImages - 1
							&& indexActualImage >= 0) {
						indexActualImage++;
					} else {
						indexActualImage = 0;
					}
					showImages(indexActualImage);
					jButton5.setEnabled(false);
					jSkeletonize.setEnabled(false);
					jButton6.setEnabled(false);
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("filter");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.runFilter(Double
							.parseDouble(jTextField2.getText()), Double
							.parseDouble(jTextField3.getText()));
					jButton5.setEnabled(true);
					jSkeletonize.setEnabled(true);
					jButton6.setEnabled(true);
					// jButton3.doClick();
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.gridx = 9;
			gridBagConstraints20.gridy = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			gridBagConstraints5.insets = new Insets(0, 0, 0, 10);
			gridBagConstraints5.gridx = 8;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.weightx = 0.0D;
			gridBagConstraints5.fill = GridBagConstraints.NONE;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.anchor = GridBagConstraints.EAST;
			gridBagConstraints13.gridy = 0;
			gridBagConstraints13.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints13.gridx = 7;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.anchor = GridBagConstraints.WEST;
			gridBagConstraints10.insets = new Insets(0, 0, 0, 10);
			gridBagConstraints10.gridx = 6;
			gridBagConstraints10.gridy = 0;
			gridBagConstraints10.weightx = 0.0D;
			gridBagConstraints10.fill = GridBagConstraints.NONE;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.anchor = GridBagConstraints.EAST;
			gridBagConstraints9.gridy = 0;
			gridBagConstraints9.weightx = 0.0D;
			gridBagConstraints9.gridx = 5;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			gridBagConstraints8.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints8.gridx = 1;
			gridBagConstraints8.gridy = 0;
			gridBagConstraints8.weightx = 0.0D;
			gridBagConstraints8.gridwidth = 1;
			gridBagConstraints8.gridheight = 1;
			gridBagConstraints8.fill = GridBagConstraints.NONE;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.anchor = GridBagConstraints.EAST;
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.gridy = 1;
			gridBagConstraints7.insets = new Insets(3, 3, 3, 3);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.anchor = GridBagConstraints.EAST;
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridy = 0;
			gridBagConstraints6.insets = new Insets(3, 3, 3, 3);
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.anchor = GridBagConstraints.WEST;
			gridBagConstraints4.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints4.gridwidth = 1;
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 1;
			gridBagConstraints4.weightx = 0.0D;
			gridBagConstraints4.gridheight = 1;
			gridBagConstraints4.fill = GridBagConstraints.NONE;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 9;
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.NONE;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.weightx = 0.0D;
			gridBagConstraints2.gridwidth = 1;
			gridBagConstraints2.gridx = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.NONE;
			gridBagConstraints1.gridx = 2;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.gridwidth = 3;
			gridBagConstraints1.weightx = 0.0D;
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setPreferredSize(new Dimension(400, 80));
			jPanel1.add(getJSlider(), gridBagConstraints1);
			jPanel1.add(getJSlider1(), gridBagConstraints2);
			jPanel1.add(getJCheckBox(), gridBagConstraints3);
			jPanel1.add(getJTextField(), gridBagConstraints4);
			jPanel1.add(jLabel2, gridBagConstraints6);
			jPanel1.add(jLabel3, gridBagConstraints7);
			jPanel1.add(getJTextField1(), gridBagConstraints8);
			jPanel1.add(jLabel, gridBagConstraints9);
			jPanel1.add(getJTextField2(), gridBagConstraints10);
			jPanel1.add(jLabel1, gridBagConstraints13);
			jPanel1.add(getJTextField3(), gridBagConstraints5);
			jPanel1.add(getJHistogram(), gridBagConstraints20);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jSlider
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider();
			jSlider.setOrientation(SwingConstants.HORIZONTAL);
			jSlider.setPaintTicks(true);
			jSlider.setPreferredSize(new Dimension(500, 40));
			jSlider.setToolTipText("max");
			jSlider.setMaximum(255);
			jSlider.setPaintLabels(false);
			jSlider.setMinorTickSpacing(30);
			jSlider.setMajorTickSpacing(30);
			jSlider.setPaintTrack(true);
			jSlider.setValue(threshold_max);
			jSlider.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (jSlider.getValue() <= jSlider1.getValue()) {
						jSlider1.setValue(jSlider.getValue());
					}
					jTextField1.setText(String.valueOf(jSlider.getValue()));
					jButton3.doClick();
				}
			});
		}
		return jSlider;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("save image");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.saveImage(filteredImageName);
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("threshold");
			jButton3.setVisible(true);
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.check(Integer.parseInt(jTextField.getText()),
							Integer.parseInt(jTextField1.getText()));
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jSlider1
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider1() {
		if (jSlider1 == null) {
			jSlider1 = new JSlider();
			jSlider1.setOrientation(SwingConstants.HORIZONTAL);
			jSlider1.setPreferredSize(new Dimension(500, 40));
			jSlider1.setToolTipText("min");
			jSlider1.setInverted(false);
			jSlider1.setBackground(new Color(238, 238, 238));
			jSlider1.setPaintLabels(true);
			jSlider1.setPaintTicks(true);
			jSlider1.setExtent(0);
			jSlider1.setMaximum(255);
			jSlider1.setMajorTickSpacing(30);
			jSlider1.setMinorTickSpacing(30);
			jSlider1.setPaintTrack(true);
			jSlider1.setValue(threshold_min);
			jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (jSlider1.getValue() >= jSlider.getValue()) {
						jSlider.setValue(jSlider1.getValue());
					}
					jTextField.setText(String.valueOf(jSlider1.getValue()));
					jButton3.doClick();
				}
			});
		}
		return jSlider1;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new Dimension(40, 20));
			jTextField.setEnabled(true);
			jTextField.setEditable(false);
			jTextField.setText(String.valueOf(threshold_min));
		}
		return jTextField;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setPreferredSize(new Dimension(40, 20));
			jTextField1.setEnabled(true);
			jTextField1.setEditable(false);
			jTextField1.setText("255");
		}
		return jTextField1;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setPreferredSize(new Dimension(40, 20));
			jTextField2.setText(String.valueOf(filter_radius));
		}
		return jTextField2;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField3() {
		if (jTextField3 == null) {
			jTextField3 = new JTextField();
			jTextField3.setPreferredSize(new Dimension(40, 20));
			jTextField3.setText(String.valueOf(filter_sigma));
		}
		return jTextField3;
	}

	/**
	 * This is the default constructor
	 */
	public FilterGauss() {
		super();
		initialize();
	}

	public FilterGauss(int thresMin, int thresMax, double radius, double sigma,
			File images, String filteredImagePrefix) {
		super();
		this.threshold_min = thresMin;
		this.threshold_max = thresMax;
		this.filter_radius = radius;
		this.filter_sigma = sigma;
		this.single_image_mode = true;
		this.images = images;
		this.filteredImagePrefix = filteredImagePrefix;
		initialize();
		showImage();
		filtered.setHistoLocation(this.getWidth(), 0);
		filtered.setHistoSize(255, this.getHeight());
	}

	public FilterGauss(int thresMin, int thresMax, double radius, double sigma,
			File[] imageSeries, String filteredImagePrefix) {
		super();
		this.threshold_min = thresMin;
		this.threshold_max = thresMax;
		this.filter_radius = radius;
		this.filter_sigma = sigma;
		this.single_image_mode = false;
		this.imagesSeries = imageSeries;
		this.numberOfImages = this.imagesSeries.length;
		this.filteredImagePrefix = filteredImagePrefix;
		initialize();
		showImages(0);
		filtered.setHistoLocation(this.getWidth(), 0);
		filtered.setHistoSize(255, this.getHeight());
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		int taskbarheight = 30;
		this.setSize(885, 171);
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle("filter");
		if (single_image_mode) {
			jButton.setEnabled(false);
		}
		if (single_image_mode) {
			jButton4.setEnabled(false);
		}
		screenWidth = this.getToolkit().getScreenSize().width;
		screenHeight = this.getToolkit().getScreenSize().height;
		windowHeight = this.getHeight();

		this.setVisible(true);

		int h = screenHeight - windowHeight;
		if (original != null) {
			original = null;
		}

		original = new MyFrame();
		original.setSize(screenWidth / 2, h - taskbarheight);
		original.setLocation(0, windowHeight);
		original.setTitle("original");

		if (filtered != null) {
			filtered = null;
		}
		filtered = new MyFrame();
		filtered.setTitle("filtered");
		filtered.setSize(screenWidth / 2, h - taskbarheight);
		filtered.setLocation(screenWidth / 2, windowHeight);

		original.setLinkedWindow(filtered);
		filtered.setLinkedWindow(original);
				
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				if (filtered != null) {
					filtered.disposeMyHistogram();
					filtered.dispose();
				}
				if (original != null) {
					original.disposeMyHistogram();
					original.dispose();
				}
				dispose();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.SOUTH);
			jContentPane.add(getJPanel1(), BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * @return the filteredImagePrefix
	 */
	public String getFilteredImagePrefix() {
		return filteredImagePrefix;
	}

	private void showImage() {
		filtered.setImage(images.getAbsolutePath(), 1);
		original.setImage(images.getAbsolutePath(), 0);
		filteredImageName = images.getParent() + File.separator
				+ filteredImagePrefix + images.getName();
		original.setRealSize(jCheckBox.isSelected());
		filtered.setRealSize(jCheckBox.isSelected());
	}

	private void showImages(int i) {
		filtered.setImage(imagesSeries[i].getAbsolutePath(), 1);
		original.setImage(imagesSeries[i].getAbsolutePath(), 0);
		filteredImageName = imagesSeries[i].getParent() + File.separator
				+ filteredImagePrefix + imagesSeries[i].getName();
		System.out.println("prefix... " + filteredImageName);
		original.setRealSize(jCheckBox.isSelected());
		filtered.setRealSize(jCheckBox.isSelected());
	}

	/**
	 * This method initializes jButton4
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("previous");
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (indexActualImage < numberOfImages
							&& indexActualImage > 0) {
						indexActualImage--;
					} else {
						indexActualImage = numberOfImages - 1;
					}
					showImages(indexActualImage);
					jButton5.setEnabled(false);
					jSkeletonize.setEnabled(false);
					jButton6.setEnabled(false);
				}
			});
		}
		return jButton4;
	}

	/**
	 * This method initializes jSkeletonize
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJSkeletonize() {
		if (jSkeletonize == null) {
			jSkeletonize = new JButton();
			jSkeletonize.setText("erode");
			jSkeletonize.setEnabled(false);
			jSkeletonize.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.erode();
				}
			});
		}
		return jSkeletonize;
	}

	/**
	 * This method initializes jButton5
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new JButton();
			jButton5.setText("dilate");
			jButton5.setEnabled(false);
			jButton5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.dilate();
				}
			});
		}
		return jButton5;
	}

	/**
	 * This method initializes jButton6
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton6() {
		if (jButton6 == null) {
			jButton6 = new JButton();
			jButton6.setText("skeletonize");
			jButton6.setEnabled(false);
			jButton6.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.skeletonize();
				}
			});
		}
		return jButton6;
	}

	/**
	 * This method initializes jButton7
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton7() {
		if (jButton7 == null) {
			jButton7 = new JButton();
			jButton7.setText("undo");
			jButton7.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					filtered.undo();
				}
			});
		}
		return jButton7;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("realSize");
			jCheckBox.setSelected(false);
			jCheckBox.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					original.setRealSize(jCheckBox.isSelected());
					filtered.setRealSize(jCheckBox.isSelected());
				}
			});
		}
		return jCheckBox;
	}

	/**
	 * This method initializes jButton8
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton8() {
		if (jButton8 == null) {
			jButton8 = new JButton();
			jButton8.setText("count pixels");
			jButton8.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					filtered.countPixels();
				}
			});
		}
		return jButton8;
	}

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu();
			jMenu.setText("calibrate system");
			jMenu.add(getJPanel11());
		}
		return jMenu;
	}

	/**
	 * This method initializes jPanel11
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel11() {
		if (jPanel11 == null) {
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			gridBagConstraints28.gridx = 2;
			gridBagConstraints28.gridy = 0;
			jYAxis = new JLabel();
			jYAxis.setText("y-axis");
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.gridx = 1;
			gridBagConstraints26.gridy = 0;
			jXAxis = new JLabel();
			jXAxis.setText("x-axis");
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			gridBagConstraints30.insets = new Insets(2, 2, 2, 2);
			gridBagConstraints30.gridy = 2;
			gridBagConstraints30.anchor = GridBagConstraints.CENTER;
			gridBagConstraints30.gridx = 3;
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			gridBagConstraints29.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints29.gridx = 2;
			gridBagConstraints29.gridy = 2;
			gridBagConstraints29.weightx = 1.0;
			gridBagConstraints29.anchor = GridBagConstraints.CENTER;
			gridBagConstraints29.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
			gridBagConstraints27.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints27.gridx = 2;
			gridBagConstraints27.gridy = 1;
			gridBagConstraints27.weightx = 1.0;
			gridBagConstraints27.anchor = GridBagConstraints.CENTER;
			gridBagConstraints27.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints25.gridx = 1;
			gridBagConstraints25.gridy = 2;
			gridBagConstraints25.weightx = 1.0;
			gridBagConstraints25.anchor = GridBagConstraints.CENTER;
			gridBagConstraints25.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints24.gridy = 2;
			gridBagConstraints24.anchor = GridBagConstraints.EAST;
			gridBagConstraints24.gridx = 0;
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints23.gridx = 1;
			gridBagConstraints23.gridy = 1;
			gridBagConstraints23.weightx = 1.0;
			gridBagConstraints23.anchor = GridBagConstraints.CENTER;
			gridBagConstraints23.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints21.gridy = 1;
			gridBagConstraints21.anchor = GridBagConstraints.EAST;
			gridBagConstraints21.gridx = 0;
			jLabel11 = new JLabel();
			jLabel11.setText("unit:");
			jLabel11.setComponentOrientation(ComponentOrientation.UNKNOWN);
			jLabel4 = new JLabel();
			jLabel4.setText("pixels:");
			jPanel11 = new JPanel();
			jPanel11.setLayout(new GridBagLayout());
			jPanel11.setPreferredSize(new Dimension(247, 76));
			jPanel11.add(jLabel4, gridBagConstraints21);
			jPanel11.add(getJTextField4(), gridBagConstraints23);
			jPanel11.add(jLabel11, gridBagConstraints24);
			jPanel11.add(getJTextField11(), gridBagConstraints25);
			jPanel11.add(getJTextField21(), gridBagConstraints27);
			jPanel11.add(getJTextField31(), gridBagConstraints29);
			jPanel11.add(getJButton21(), gridBagConstraints30);
			jPanel11.add(jXAxis, gridBagConstraints26);
			jPanel11.add(jYAxis, gridBagConstraints28);
		}
		return jPanel11;
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField4() {
		if (jTextField4 == null) {
			jTextField4 = new JTextField();
			jTextField4.setName("kali_Pix_X");
			jTextField4.setText("0");
			jTextField4.setPreferredSize(new Dimension(50, 20));
		}
		return jTextField4;
	}

	/**
	 * This method initializes jTextField11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField11() {
		if (jTextField11 == null) {
			jTextField11 = new JTextField();
			jTextField11.setName("kali_Laenge_X");
			jTextField11.setText("0");
			jTextField11.setPreferredSize(new Dimension(50, 20));
		}
		return jTextField11;
	}

	/**
	 * This method initializes jTextField21
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField21() {
		if (jTextField21 == null) {
			jTextField21 = new JTextField();
			jTextField21.setName("kali_Pix_Y");
			jTextField21.setText("0");
			jTextField21.setPreferredSize(new Dimension(50, 20));
		}
		return jTextField21;
	}

	/**
	 * This method initializes jTextField31
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField31() {
		if (jTextField31 == null) {
			jTextField31 = new JTextField();
			jTextField31.setName("kali_Laenge_Y");
			jTextField31.setText("0");
			jTextField31.setPreferredSize(new Dimension(50, 20));
		}
		return jTextField31;
	}

	/**
	 * This method initializes jButton21
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton21() {
		if (jButton21 == null) {
			jButton21 = new JButton();
			jButton21.setText("calibrate");
			jButton21.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					filtered.setCalibration(Double.parseDouble(jTextField4
							.getText()), Double.parseDouble(jTextField11
							.getText()), Double.parseDouble(jTextField21
							.getText()), Double.parseDouble(jTextField31
							.getText()));
					jButton21.setText("set");
					filtered.requestFocus();
				}
			});
		}
		return jButton21;
	}

	/**
	 * This method initializes jHistogram	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJHistogram() {
		if (jHistogram == null) {
			jHistogram = new JCheckBox();
			jHistogram.setText("histogram");
			jHistogram.setSelected(true);
			jHistogram.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					if(filtered!=null){
						filtered.setVisibleHistogram(jHistogram.isSelected());
					}
				}
			});
		}
		return jHistogram;
	}

} // @jve:decl-index=0:visual-constraint="10,9"
